"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const global_js_1 = require("../tool/global.js");
const storage_js_1 = __importDefault(require("../tool/storage.js"));
const vue_1 = require("vue");
const alone_js_1 = __importDefault(require("../tool/alone.js"));
const http_js_1 = __importDefault(require("../tool/http.js"));
exports.default = {
    //路由对像
    route: {},
    //路由参数
    routes: [],
    //i188对像
    i18n: {},
    //配置
    config: (0, global_js_1.global)("aloneFrameConfigApp"),
    //获取env
    get_env(key = null) {
        return alone_js_1.default.get_arr(process.env, key, '');
    },
    //获取config
    get_config(key = null, def = null) {
        return this.config.get(key, def);
    },
    //获取配置
    get_conf(key = null, def = null) {
        return alone_js_1.default.get_arr(this.get_config('conf'), key, def);
    },
    //获取第一次来路
    get_origin() {
        return storage_js_1.default.get('originCache');
    },
    //获取访问标识
    get_make() {
        return storage_js_1.default.get('makeCache');
    },
    //http请求
    http(path) {
        return (0, http_js_1.default)((import.meta.env.MODE === 'preview' ? '/api' : this.get_env('api'))).path(path).cross(true);
    },
    //设置标题
    set_title(title = '') {
        return alone_js_1.default.set_title(title || this.get_config('title'));
    },
    //获取和设置语言名称
    get_locale(locale = '', fallback = '') {
        if (alone_js_1.default.isset(locale)) {
            this.i18n.global.locale = locale;
            storage_js_1.default.set('langLocale', locale);
        }
        if (alone_js_1.default.isset(fallback)) {
            this.i18n.global.fallbackLocale = fallback;
        }
        return storage_js_1.default.get('langLocale', locale);
    },
    //获取语言内容
    get_lang(key, tag = {}) {
        return this.i18n.global.t(key, tag);
    },
    //设置语言
    set_lang(key, val = null, lang = '', merge = true) {
        const object = this.i18n.global;
        const value = alone_js_1.default.is_object(key) ? key : alone_js_1.default.set_arr(key, val);
        const locale = lang ? lang : this.get_locale();
        merge ? object.mergeLocaleMessage(locale, value) : object.setLocaleMessage(locale, value);
        return value;
    },
    //路由跳转
    route_path(path, { name = '', params = {}, query = {}, hash = '' } = {}) {
        this.route.push({ path: path, name: name, params: params, query: query, hash: hash });
    },
    //获取路由
    get_route(key = '', def = null) {
        return alone_js_1.default.get_arr(this.route.currentRoute.value, key, def);
    },
    //判断路由
    is_route(val, key = 'path', type = false) {
        return this.route.getRoutes().some(record => (alone_js_1.default.get_arr(record, key, null) === type ? this.get_route(val) : val));
    },
    /**
     * 代替this
     * @param type
     * @returns {
     * import('vue-router').ComponentPublicInstance &
     * {
     *     $route: import('vue-router')._RouteRecordBase,
     *     $router: import('vue-router').Router,
     *     $i18n: import('vue-i18n').I18n
     * }
     * }
     */
    then(type = null) {
        var _a;
        const { proxy, appContext } = (0, vue_1.getCurrentInstance)();
        const global = ((_a = appContext === null || appContext === void 0 ? void 0 : appContext.config) === null || _a === void 0 ? void 0 : _a.globalProperties) || {};
        return ((type === null) ? proxy : (type === true ? Object.assign(proxy, global) : global));
    }
};
