"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const vue_router_1 = require("vue-router");
const getVue_js_1 = __importDefault(require("../route/getVue.js"));
const storage_js_1 = __importDefault(require("../tool/storage.js"));
const vue_1 = require("@unhead/vue");
const alone_js_1 = __importDefault(require("../tool/alone.js"));
const vue_i18n_1 = require("vue-i18n");
const safe_js_1 = __importDefault(require("../tool/safe.js"));
const nprogress_1 = __importDefault(require("nprogress"));
const App_vue_1 = __importDefault(require("@src/App.vue"));
const vue_2 = require("vue");
const app_js_1 = __importDefault(require("./app.js"));
exports.create = (0, vue_2.createApp)(App_vue_1.default);
const self = {
    //本地设置的路由,和远程路由
    route: { local: [], web: [] },
    plugins(key) {
        return alone_js_1.default.get_arr(process.plugins, key);
    },
    //加载本地配置
    local_conf() {
        const local = process.config || { data: null, random: null };
        const conf = ((local.data || '' && local.random || '') ? (safe_js_1.default.mov.de(local) || local) : local);
        if (alone_js_1.default.isset(conf)) {
            this.route.local = conf.route || [];
            app_js_1.default.config.object(alone_js_1.default.del_key(conf, 'route'));
        }
        return this;
    },
    //加载远程配置
    web_conf() {
        return __awaiter(this, void 0, void 0, function* () {
            const conf_file = app_js_1.default.get_env('conf');
            if (alone_js_1.default.isset(conf_file) && alone_js_1.default.is_string(conf_file)) {
                const res = yield app_js_1.default.http(conf_file).query({
                    data: safe_js_1.default.url.en({
                        make: app_js_1.default.get_make(),
                        origin: app_js_1.default.get_origin(),
                        domain: alone_js_1.default.domain.domain()
                    })
                }).get(function (res) {
                    if ((res.data || '') && (res.random || '')) {
                        return (safe_js_1.default.mov.de(res) || res);
                    }
                    else if (res.code == 200) {
                        return res.data;
                    }
                    else if (alone_js_1.default.is_object(res)) {
                        return res;
                    }
                    return false;
                }, function () {
                    return false;
                });
                if (alone_js_1.default.isset(res)) {
                    this.route.web = res.route || [];
                    app_js_1.default.config.object(alone_js_1.default.del_key(res, 'route'));
                }
            }
            return this;
        });
    },
    process() {
        return __awaiter(this, void 0, void 0, function* () {
            //有效时间
            const make_time = parseInt(app_js_1.default.config.get('make_time', 28800));
            //生成访问标识
            if (!alone_js_1.default.isset(app_js_1.default.get_make())) {
                storage_js_1.default.set('makeCache', alone_js_1.default.get_token(), make_time);
            }
            //保存第一次的来路
            if (!alone_js_1.default.isset(app_js_1.default.get_origin())) {
                const origin = alone_js_1.default.origin.get();
                if (alone_js_1.default.isset(origin)) {
                    storage_js_1.default.set('originCache', origin, make_time);
                }
            }
            this.local_conf();
            yield this.web_conf();
            app_js_1.default.set_title();
            return this;
        });
    },
    //处理路由
    load_route(view = {}) {
        this.route_list = (0, getVue_js_1.default)(Object.assign(app_js_1.default.config.get('routing', {}) || {}, { view: view }), this.route.local || [], this.route.web || []);
        app_js_1.default.config.list().route = this.route_list.route;
        this.route_config = this.route_list.routes || [];
        return this;
    },
    load_i18n() {
        this.i18n_config = {
            locale: app_js_1.default.config.get('locale'),
            fallback: app_js_1.default.config.get('fallback'),
            messages: app_js_1.default.config.get('lang'),
        };
        return this;
    },
    start_route(array) {
        if (alone_js_1.default.isset(array)) {
            app_js_1.default.routes = (alone_js_1.default.is_object(array) ? Object.values(array) : array);
            app_js_1.default.route = (0, vue_router_1.createRouter)({ history: (0, vue_router_1.createWebHashHistory)(import.meta.env.BASE_URL), routes: app_js_1.default.routes });
            const black = ' style="display: block"';
            const none = ' style="display: none"';
            const bar = (app_js_1.default.config.get('load_bar') == true || app_js_1.default.config.get('load_bar') == 1) ? black : none;
            const ico = (app_js_1.default.config.get('load_ico') == true || app_js_1.default.config.get('load_ico') == 1) ? black : none;
            //启动 进度条和加载图标
            const bar_start = () => nprogress_1.default.start();
            //关闭 进度条和加载图标
            const bar_close = () => nprogress_1.default.done();
            nprogress_1.default.settings.template = `<div class="bar" role="bar"${bar}><div class="peg"></div></div><div class="spinner" role="spinner"${ico}><div class="spinner-icon"></div></div>`;
            app_js_1.default.route.beforeEach((to, from, next) => {
                const title = alone_js_1.default.get_arr(to, 'meta.title', null);
                if (alone_js_1.default.isset(title)) {
                    app_js_1.default.set_title(title);
                }
                if (to.matched.length) {
                    bar_start();
                    next();
                }
                else {
                    const error = app_js_1.default.config.get('error');
                    if (!error) {
                        return false;
                    }
                    next(error);
                }
            });
            app_js_1.default.route.afterEach(() => (bar_close()));
            app_js_1.default.route.onError(() => (bar_close()));
            exports.create.use(app_js_1.default.route);
        }
        return this;
    },
    start_i18n({ locale, fallback, messages } = {}) {
        if (alone_js_1.default.isset(locale)) {
            locale = storage_js_1.default.get('langLocale') || locale;
            app_js_1.default.i18n = (0, vue_i18n_1.createI18n)({ locale: locale, fallbackLocale: fallback || locale, messages: messages });
            app_js_1.default.get_locale(locale, fallback);
            exports.create.use(app_js_1.default.i18n);
        }
        return this;
    },
    main() {
        return __awaiter(this, arguments, void 0, function* (view = {}) {
            yield this.process();
            this.load_route(view).load_i18n();
            this.start_route(this.route_config).start_i18n(this.i18n_config);
            Promise.resolve().then(() => __importStar(require('vfonts/Lato.css')));
            Promise.resolve().then(() => __importStar(require('vfonts/FiraCode.css')));
            Promise.resolve().then(() => __importStar(require('../style/css/bar.css')));
            return this;
        });
    }
};
exports.default = {
    app: App_vue_1.default,
    create: exports.create,
    createApp: vue_2.createApp,
    status: {},
    use(plugin) {
        return exports.create.use(plugin);
    },
    //加载前
    load() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.status.load) {
                this.status.load = true;
                if (self.plugins('markdown')) {
                    this.use((0, vue_1.createHead)());
                }
                yield self.main();
            }
            return self;
        });
    },
    //加载后
    mount() {
        if (!this.status.mount) {
            this.status.mount = true;
            this.create.mount('#' + app_js_1.default.get_env('app'));
        }
        return this.create;
    }
};
