"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = default_1;
const alone_js_1 = __importDefault(require("../tool/alone.js"));
const vueList_js_1 = __importDefault(require("./vueList.js"));
//生成动态路由
const create_local_array = function (view, group, index = 'index', route = [], is_index = false) {
    Object.keys(view).forEach((path) => {
        let is_group = false;
        if (alone_js_1.default.isset(group)) {
            const arr = path.split('/');
            Object.keys(group).forEach(k => {
                const value = alone_js_1.default.trim(group[k], '/');
                const key = k.split('/');
                const len = key.length;
                if (arr.length > len && arr.slice(0, len).join('/') == alone_js_1.default.trim(k, '/')) {
                    is_group = true;
                    let parent = route.find(r => r.path === value);
                    if (!parent) {
                        parent = { path: value, alias: value.split('/').slice(0, -1).join('/'), children: [] };
                        route.push(parent);
                    }
                    if (value != path) {
                        parent.children.push({ path: path });
                    }
                }
            });
        }
        if (is_group === false) {
            if (path === alone_js_1.default.trim(index || "index", '/')) {
                is_index = true;
                route.push({ path: path, alias: '/' });
            }
            else {
                route.push({ path: path });
            }
        }
    });
    if (is_index === false && alone_js_1.default.isset(route)) {
        route[0].alias = '/';
    }
    return route;
};
//合并路由配置
const merge_route = function (arr, array, merge = false, map = {}) {
    if (alone_js_1.default.isset(arr) && alone_js_1.default.isset(array)) {
        arr.forEach(v => (map[v.path] = Object.assign({}, v)));
        array.forEach(v => {
            const obj = map[v.path] || {};
            map[v.path] = merge ? Object.assign(Object.assign({}, obj), v) : Object.assign({}, v);
            if (v.children) {
                map[v.path].children = merge_route(obj.children || [], v.children, merge);
            }
        });
        return Object.values(map);
    }
    else if (alone_js_1.default.isset(array)) {
        return array;
    }
    return arr;
};
//生成路由array
const create_route = function (view, arr, array = []) {
    if (alone_js_1.default.isset(arr)) {
        arr = alone_js_1.default.is_object(arr) ? Object.values(arr) : arr;
        for (const val of arr) {
            const v = Object.assign({}, val);
            const path = alone_js_1.default.trim(v.path || '', '/');
            let component = v.component ? v.component : path;
            if (component) {
                if (alone_js_1.default.is_string(component) || alone_js_1.default.is_number(component)) {
                    component = view[alone_js_1.default.trim(component, '/')];
                }
                if (component) {
                    v.path = "/" + path;
                    (v.alias) && (v.alias = "/" + alone_js_1.default.trim(v.alias, '/'));
                    (!v.name) && (v.name = path.replace(/\./g, '_').replace(/\//g, '_'));
                    v.component = component;
                    (v.children) && (v.children = create_route(view, v.children));
                    array.push(v);
                }
            }
        }
    }
    return array;
};
//是否开启动态路由,默认首页,分组,...路由设置
function default_1({ status, index, group, view }, ...array) {
    let route = [], routes = [];
    const viewList = (alone_js_1.default.isset(view) ? view : vueList_js_1.default) || {};
    if (alone_js_1.default.isset(viewList)) {
        alone_js_1.default.isset(array) && array.forEach((arr) => (route = merge_route(route, arr, true)));
        route = (status || status === undefined) ? merge_route(create_local_array(viewList, group, index), route) : route;
        route = alone_js_1.default.isset(route) ? route : create_local_array(viewList, group, index);
        routes = create_route(viewList, route);
    }
    return { route: route, routes: routes, view: viewList };
}
