"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setVuePlugins = exports.setView = exports.delView = void 0;
const nodes_js_1 = require("../tool/nodes.js");
const glob_1 = require("glob");
const nodes_js_2 = __importDefault(require("../tool/nodes.js"));
const alone_js_1 = __importDefault(require("../tool/alone.js"));
const url_1 = require("url");
//获取view列表
const view_file = function (view_path, exclude = {}, route = "{", i = 0) {
    (0, glob_1.sync)(view_path + '/**/*.vue').forEach((file) => {
        let status = true;
        const path = alone_js_1.default.trim(file.replace(/\\/g, '/').replace(/\.vue$/, '').replace(view_path, ''), '/');
        if (alone_js_1.default.isset(exclude)) {
            const arr = path.split('/');
            const dir_list = exclude.dir || [];
            const dir_name = arr.length > 1 ? arr.slice(0, -1).join('/') : "";
            if (alone_js_1.default.isset(dir_list) && alone_js_1.default.isset(dir_name)) {
                if (dir_list.includes(dir_name)) {
                    status = false;
                }
            }
            if (status === true) {
                const file_list = exclude.file || [];
                if (alone_js_1.default.isset(file_list)) {
                    if (file_list.includes(path)) {
                        status = false;
                    }
                }
            }
        }
        if (status === true) {
            ++i;
            route += `\r\n        "${path}": () => import(\`${view_path}/${path}.vue\`),`;
        }
    });
    return (i > 0 ? alone_js_1.default.trim(route, ',') + "\r\n    }" : "{}");
};
const delView = function () {
    const node = (0, nodes_js_2.default)((0, nodes_js_1.dir_name)((0, url_1.fileURLToPath)(import.meta.url)));
    node.save_file(`vueList.js`, `export default {}`);
};
exports.delView = delView;
//设置view目录,排除文件或者目录(文件不用输入格式),run是否根目录
const setView = function (view_dir, { dir = [], file = [], run = false } = {}) {
    const node = (0, nodes_js_2.default)((0, nodes_js_1.dir_name)((0, url_1.fileURLToPath)(import.meta.url)));
    const view_path = run === false ? alone_js_1.default.rtrim(process.cwd(), '/') + "/" + alone_js_1.default.trim(view_dir, '/') : view_dir;
    const json = view_file(view_path.replace(/\\/g, '/'), { dir, file });
    node.save_file(`vueList.js`, `export default ${json}`);
    return json;
};
exports.setView = setView;
const setVuePlugins = function (view_dir, { dir = [], file = [], run = false } = {}) {
    return {
        name: 'alone-route',
        buildStart() {
            (0, exports.setView)(view_dir, { dir: dir, file: file, run: run });
        }
    };
};
exports.setVuePlugins = setVuePlugins;
exports.default = exports.setView;
