"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const alone_js_1 = __importDefault(require("./alone.js"));
exports.default = {
    //time为有效时间/秒
    set(key, val, time = 0, { path = '/', domain = null } = {}) {
        const value = alone_js_1.default.to_str(val);
        let cookie = `${key}=${encodeURIComponent(alone_js_1.default.to_str(val))}`;
        if (time > 0) {
            const expires = new Date(Date.now() + time * 1000).toUTCString();
            cookie += `; expires=${expires}`;
        }
        document.cookie = `${cookie}; path=${path}; domain=${domain || document.domain};`;
        return value;
    },
    get(key = null, def = null) {
        return alone_js_1.default.get_arr(this.list(), key, def);
    },
    del(key, { path = '/', domain = null } = {}) {
        const remove = function (k) {
            document.cookie = `${k}=; path=${path}; domain=${domain || document.domain}; expires=Thu, 01 Jan 1970 00:00:00 UTC;`;
        };
        if (alone_js_1.default.isset(key)) {
            if (alone_js_1.default.is_array(key)) {
                key.forEach((k) => remove(k));
            }
            else {
                remove(key);
            }
        }
    },
    delete() {
        this.del(Object.keys(this.list()));
    },
    list() {
        const list = (document.cookie || '').split("; ");
        return alone_js_1.default.isset(list) ? (list.reduce((acc, curr) => {
            const [key, val] = curr.split("=");
            const value = alone_js_1.default.to_obj(decodeURIComponent(val));
            if (key && alone_js_1.default.isset(value)) {
                acc[key] = value;
            }
            return acc;
        }, {})) : {};
    }
};
