"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const alone_js_1 = __importDefault(require("./alone.js"));
exports.default = {
    set(key, val) {
        const value = alone_js_1.default.to_str(val);
        window.sessionStorage.setItem(key, value);
        return value;
    },
    get(key = null, def = null) {
        return alone_js_1.default.get_arr(this.list(), key, def);
    },
    del(key) {
        if (alone_js_1.default.isset(key)) {
            if (alone_js_1.default.is_array(key)) {
                key.forEach((k) => window.sessionStorage.removeItem(k));
            }
            else {
                window.sessionStorage.removeItem(key);
            }
        }
    },
    delete() {
        window.sessionStorage.clear();
    },
    list() {
        const arr = {};
        const obj = window.sessionStorage;
        Object.keys(obj).forEach((key) => {
            const val = alone_js_1.default.to_obj(obj[key]);
            if (key && alone_js_1.default.isset(val)) {
                arr[key] = val;
            }
        });
        return arr;
    }
};
