"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const alone_js_1 = __importDefault(require("./alone.js"));
exports.default = {
    set(key, val, time = 0) {
        window.localStorage.setItem(key, alone_js_1.default.to_str({
            data: val,
            time: ((time || 0) > 0 ? (alone_js_1.default.get_time() + time) : 0)
        }));
        return val;
    },
    get(key = null, def = null) {
        return alone_js_1.default.get_arr(this.list(), key, def);
    },
    del(key) {
        if (alone_js_1.default.isset(key)) {
            if (alone_js_1.default.is_array(key)) {
                key.forEach((k) => window.localStorage.removeItem(k));
            }
            else {
                window.localStorage.removeItem(key);
            }
        }
    },
    delete() {
        window.localStorage.clear();
    },
    list() {
        const arr = {};
        const obj = window.localStorage;
        Object.keys(obj).forEach((key) => {
            const val = alone_js_1.default.to_obj(obj[key]) || {};
            if (val.time > 0 && alone_js_1.default.get_time() > val.time) {
                this.del(key);
            }
            else if (key && alone_js_1.default.isset(val.data)) {
                arr[key] = val.data;
            }
        });
        return arr;
    }
};
